﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Web;
using System.Web.UI;
using System.Web.UI.WebControls;

namespace DisplayZero_CellType
{
    public partial class WebForm1 : System.Web.UI.Page
    {
        protected void Page_Load(object sender, EventArgs e)
        {
            if (!IsPostBack)
            {
                FpSpread1.ActiveSheetView.RowCount = 10;
                FpSpread1.ActiveSheetView.ColumnCount = 10;
                FpSpread1.ActiveSheetView.Columns[0].CellType = new CDoubleCellType();
                FpSpread1.ActiveSheetView.Columns[0].Formula = "B1*C1";
                FpSpread1.ClientAutoCalculation = true;

                FpSpread1.ActiveSheetView.Columns[3].CellType = new CDoubleCellType();
            }
        }


        [Serializable]
        public class CDoubleCellType : FarPoint.Web.Spread.DoubleCellType
        {
            public override string Format(object obj)
            {
                if (obj != null && Convert.ToDouble(obj.ToString()) == 0)
                {
                    return "";
                }
                else
                {
                    return base.Format(obj);
                }
            }

            public override object Parse(string s)
            {
                if (s == "" || s == "0")
                {
                    return 0;
                }
                else
                {
                    return base.Parse(s);
                }
            }
        }
    }
}